﻿using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.ComponentModel;

// Add a reference to system.data.linq. This is a Windows Phone-specific version of LINQ, in the assembly
// C:\%ProgramFiles%\Reference Assemblies\Microsoft\Framework\Silverlight\v4.0\Profile\WindowsPhone71\system.data.linq.dll

namespace MangoDatabaseCreator
{
    public class MangoDataContext : DataContext
    {
        // We can only create a database in isolated storage.
        public MangoDataContext()
            //: base("Data Source=appdata:/Mangolicious.sdf;File Mode=read only;")
            : base("Data Source=isostore:/Mangolicious.sdf")
        {
        }

        public Table<Recipe> Recipes;
        public Table<Fact> Facts;
        public Table<Cocktail> Cocktails;
    }


    #region Recipes

    [Table]
    public class Recipe
    {
        private int id;
        [Column(
            IsPrimaryKey = true, IsDbGenerated = true, 
            DbType = "INT NOT NULL Identity", CanBeNull = false, 
            AutoSync = AutoSync.OnInsert)]
        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                }
            }
        }

        private string name;
        [Column(DbType = "NVARCHAR(32)")]
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                }
            }
        }

        private string photo;
        [Column(DbType = "NVARCHAR(255)")]
        public string Photo
        {
            get { return photo; }
            set
            {
                if (photo != value)
                {
                    photo = value;
                }
            }
        }

        private string ingredients;
        [Column(DbType = "NVARCHAR(512)")]
        public string Ingredients
        {
            get { return ingredients; }
            set
            {
                if (ingredients != value)
                {
                    ingredients = value;
                }
            }
        }

        private string instructions;
        [Column(DbType = "NVARCHAR(1024)")]
        public string Instructions
        {
            get { return instructions; }
            set
            {
                if (instructions != value)
                {
                    instructions = value;
                }
            }
        }

        private string season;
        [Column(DbType = "NVARCHAR(8)")]
        public string Season
        {
            get { return season; }
            set
            {
                if (season != value)
                {
                    season = value;
                }
            }
        }
    }

    #endregion


    #region Facts

    [Table]
    public class Fact
    {
        private int id;
        [Column(
            IsPrimaryKey = true, IsDbGenerated = true,
            DbType = "INT NOT NULL Identity", CanBeNull = false,
            AutoSync = AutoSync.OnInsert)]
        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                }
            }
        }

        private string name;
        [Column(DbType = "NVARCHAR(32)")]
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                }
            }
        }

        private string photo;
        [Column(DbType = "NVARCHAR(255)")]
        public string Photo
        {
            get { return photo; }
            set
            {
                if (photo != value)
                {
                    photo = value;
                }
            }
        }

        private string body;
        [Column(DbType = "NVARCHAR(1024)")]
        public string Body
        {
            get { return body; }
            set
            {
                if (body != value)
                {
                    body = value;
                }
            }
        }
    }

    #endregion


    #region Cocktails

    [Table]
    public class Cocktail
    {
        private int id;
        [Column(
            IsPrimaryKey = true, IsDbGenerated = true,
            DbType = "INT NOT NULL Identity", CanBeNull = false,
            AutoSync = AutoSync.OnInsert)]
        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                }
            }
        }

        private string name;
        [Column(DbType = "NVARCHAR(32)")]
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                }
            }
        }

        private string photo;
        [Column(DbType = "NVARCHAR(255)")]
        public string Photo
        {
            get { return photo; }
            set
            {
                if (photo != value)
                {
                    photo = value;
                }
            }
        }

        private string ingredients;
        [Column(DbType = "NVARCHAR(512)")]
        public string Ingredients
        {
            get { return ingredients; }
            set
            {
                if (ingredients != value)
                {
                    ingredients = value;
                }
            }
        }

        private string instructions;
        [Column(DbType = "NVARCHAR(1024)")]
        public string Instructions
        {
            get { return instructions; }
            set
            {
                if (instructions != value)
                {
                    instructions = value;
                }
            }
        }

        private string season;
        [Column(DbType = "NVARCHAR(8)")]
        public string Season
        {
            get { return season; }
            set
            {
                if (season != value)
                {
                    season = value;
                }
            }
        }
    }

    #endregion

}
