using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace MangoClient
{
    public class Player
    {
        // Animation representing the player,
        public Animation PlayerAnimation;

        // Position of the Player relative to the upper left side of the screen,
        public Vector2 Position;

        public bool Active;
        public int Health;

        public int Width
        {
            get { return PlayerAnimation.FrameWidth; }
        }

        public int Height
        {
            get { return PlayerAnimation.FrameHeight; }
        }

        // Initialize the player.
        public void Initialize(Animation animation, Vector2 position)
        {
            PlayerAnimation = animation;
            Position = position;
            Active = true;
        }

        // Update the player animation.
        public void Update(TimeSpan totalTime, TimeSpan elapsedTime)
        {
            PlayerAnimation.Position = Position;
            PlayerAnimation.Update(totalTime, elapsedTime);
        }

        // Draw the player.
        public void Draw(SpriteBatch spriteBatch)
        {
            PlayerAnimation.Draw(spriteBatch);
        }
    }
}
